VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Insert Comments"
Option Explicit

Implements IDTExtensibility

Public WithEvents MenuHandler          As CommandBarEvents
Attribute MenuHandler.VB_VarHelpID = -1

Private m_objVBInstance                As VBIDE.VBE
Private m_objMenuCommandBar            As Office.CommandBarControl
Private m_lngEndColumn                 As String

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub IDTExtensibility_OnConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [KPMG]
' Date Writen  : 05/31/1998 -- 00:02:42
' Inputs       : ByVal VBInst:Object -
'              : ByVal ConnectMode:vbext_ConnectMode -
'              : ByVal AddInInst:VBIDE.AddIn -
'              : custom():Variant -
' Outputs      : N/A
' Description  :
'              :
'              :
' *******************************************************
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, _
                                          ByVal ConnectMode As vbext_ConnectMode, _
                                          ByVal AddInInst As VBIDE.AddIn, _
                                          custom() As Variant)
   Set m_objVBInstance = VBInst
   Set m_objMenuCommandBar = m_objVBInstance.CommandBars("Edit").Controls.Add
   
   m_objMenuCommandBar.Caption = "Insert Comments"
   Clipboard.SetData LoadResPicture(101, vbResBitmap)

   m_objMenuCommandBar.PasteFace
   
   Set Me.MenuHandler = m_objVBInstance.Events.CommandBarEvents(m_objMenuCommandBar)
   
   m_lngEndColumn = CLng(GetSetting(App.Title, "Settings", "EndColumn", ""))

End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub IDTExtensibility_OnDisconnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [KPMG]
' Date Writen  : 05/31/1998 -- 00:02:58
' Inputs       : ByVal RemoveMode:vbext_DisconnectMode -
'              : custom():Variant -
' Outputs      : N/A
' Description  :
'              :
'              :
' *******************************************************
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, _
                                             custom() As Variant)
   m_objMenuCommandBar.Delete
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub IDTExtensibility_OnStartupComplete
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [KPMG]
' Date Writen  : 05/31/1998 -- 00:03:12
' Inputs       : custom():Variant -
' Outputs      : N/A
' Description  :
'              :
'              :
' *******************************************************
Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
'
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub IDTExtensibility_OnAddInsUpdate
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [KPMG]
' Date Writen  : 05/31/1998 -- 00:03:18
' Inputs       : custom():Variant -
' Outputs      : N/A
' Description  :
'              :
'              :
' *******************************************************
Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
'
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub MenuHandler_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [KPMG]
' Date Writen  : 05/31/1998 -- 00:25:23
' Inputs       : ByVal CommandBarControl:Object -
'              : handled:Boolean -
'              : CancelDefault:Boolean -
' Outputs      : N/A
' Description  :
'              :
'              :
' *******************************************************
Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, _
                              handled As Boolean, _
                              CancelDefault As Boolean)
On Error Resume Next
   Dim p_lngStartLine                  As Long
   Dim p_lngStartCol                   As Long
   Dim p_lngEndLine                    As Long
   Dim p_lngEndCol                     As Long
   Dim p_lngCorrectedStartCol          As Long
   Dim p_lngNumDashes                  As Long
   Dim p_lngDiff                       As Long
   Dim p_strIndent                     As String
    
   With m_objVBInstance.ActiveCodePane
      
      ' ---------------------------------------
      ' Get the selected line(s)
      ' ---------------------------------------
      .GetSelection p_lngStartLine, _
                    p_lngStartCol, _
                    p_lngEndLine, _
                    p_lngEndCol
      
      ' ---------------------------------------
      ' All we need is the start column --
      '     make sure it's divisible by 3
      ' ---------------------------------------
      If p_lngStartCol = 1 Then
         ' This is OK
         p_strIndent = ""
         p_lngCorrectedStartCol = 1
      ElseIf (p_lngStartCol - 1) Mod 3 <> 0 Then
         ' ------------------------------------
         ' Subtract 1
         ' ------------------------------------
         p_lngCorrectedStartCol = p_lngStartCol - 1
         
         ' ------------------------------------
         ' Make divisible by 3
         ' ------------------------------------
         p_lngDiff = 3 - (p_lngCorrectedStartCol Mod 3)
         p_lngCorrectedStartCol = p_lngCorrectedStartCol + p_lngDiff
         
         ' ------------------------------------
         ' Set the indent string
         ' ------------------------------------
         p_strIndent = String$(p_lngCorrectedStartCol, " ")
      Else
         ' ------------------------------------
         ' Set the indent string
         ' ------------------------------------
         p_lngCorrectedStartCol = p_lngStartCol - 1
         p_strIndent = String$(p_lngCorrectedStartCol, " ")
      End If
      
      ' ---------------------------------------
      ' Get the number of dashes to place
      ' Make sure you have at least 10
      ' ---------------------------------------
      p_lngNumDashes = m_lngEndColumn - p_lngCorrectedStartCol - 3
      If p_lngNumDashes < 10 Then
         p_lngNumDashes = 10
      End If
      
      ' ---------------------------------------
      ' Add the comment section
      ' ---------------------------------------
      .CodeModule.InsertLines p_lngStartLine, p_strIndent & "' " & String$(p_lngNumDashes, "-")
      .CodeModule.InsertLines p_lngStartLine, p_strIndent & "'"
      .CodeModule.InsertLines p_lngStartLine, p_strIndent & "' " & String$(p_lngNumDashes, "-")
   End With

On Error GoTo 0
End Sub

